// Ansteuerung einer 8x8-Matrix mit Maxim 7219-Chip
// 3.5.2014 
// Reinhard Atzbach

int din = 2;  // Data in:     Datenleitung (kann nur 0 oder 1 sein)
int cs  = 3;  // Chip Select: LOW=Übertragung im Gange
int clk = 4;  // Clock:       LOW->HIGH schiebt jeweils ein Bit zum Chip

void putByte(byte data) {          // Serielle Übertragung eines Bytes
  for (byte i=128 ; i>0 ; i=i/2) { // von höchster zu niedrigster Stelle
    digitalWrite(clk,LOW);    
    if (data & i){                 // Wenn im Datenbyte eine 1 steht, 
      digitalWrite(din,HIGH);      // dann setze Datenleitung auf 1
    } else {
      digitalWrite(din,LOW);       // sonst setze Datenleitung auf 0
    }
    digitalWrite(clk,HIGH);        // Wenn clk von LOW auf HIGH geht
  }                                // schiebe alle Bits eine Stelle nach links
}                                  // und setze die Einerstelle.

void set(byte regNum, byte dataByte) {  //setzt Register des Chips  
  digitalWrite(cs,LOW);                 // Übertragung beginnt
  putByte(regNum);                      // sendet Adresse
  putByte(dataByte);                    // sendet Daten
  digitalWrite(cs,HIGH);                // Übertragung beendet, Daten gültig
}

void setup () {
  pinMode(din,OUTPUT); // Alle drei Leitungen auf Ausgabemodus
  pinMode(clk,OUTPUT);
  pinMode(cs,OUTPUT);    
                       // Initialisiere die Steuerregister des MAX7219-Chips  
  set( 9,0);   // decodeMode:  0=LED-Matrix
  set(10,5);   // inensity:    LED-Helligkeit
  set(11,7);   // ScanLimit:   Spalte 0-7, 8x8-Matrix angeschlossen
  set(12,1);   // Shutdown:    aktiviert alle LED  
                       // 1 bis 8 sind die Datenregister für die Zeilen 1 bis 8
  set(1,B00000000);  
  set(2,B00000000);  
  set(3,B00000000);  
  set(4,B00011000);  
  set(5,B00011000);  
  set(6,B00000000);  
  set(7,B00000000);  
  set(8,B00000000);  
}     

void loop () {
}


